closurecompiler
ClosureCompiler.js: Closure Compiler for node.js. The all-round carefree package.
Last updated 6 years ago .
· Repository · Bugs · Original npm · Tarball · package.json
$ cnpm install closurecompiler -g
SYNC missed versions from official npm registry.

ClosureCompiler.js - Closure Compiler for node.js

Deprecation notice: This project is outdated. Alternatives:

The all-round carefree package. Automatically downloads and sets up Closure Compiler and a JRE built from OpenJDK if required. No environment variables to set, works out of the box.

Installation

Install: npm -g install closurecompiler

Installing globally is recommended if no global JRE is available and the bundled JRE needs to be downloaded, which is about 45mb large.

ClosureCompiler API

The API is quite simple and fully explained in a few lines of code:

var ClosureCompiler = require("closurecompiler");

ClosureCompiler.compile(
    ['file1.js', 'file2.js'],
    {
        // Options in the API exclude the "--" prefix
        compilation_level: "ADVANCED_OPTIMIZATIONS",
        
        // Capitalization does not matter 
        Formatting: "PRETTY_PRINT",
        
        // If you specify a directory here, all files inside are used
        externs: ["externs/file3.js", "externs/contrib/"],
        
        // ^ As you've seen, multiple options with the same name are
        //   specified using an array.
        ...
    },
    function(error, result) {
        if (result) {
            // Write result to file
            // Display error (warnings from stderr)
        } else {
            // Display error...
         }
    }
);

Command line utility

Usage:   ccjs sourceFiles...|- [--option=value --flagOption ...] [> outFile]

Available options

The API and ccjs support all the command line options of Closure Compiler except --js and --js_output_file.

Additional options:

  • JVM parameters -xms and -xmx are supported (lower case) just in case that you run out of heap space compiling a rather large code base. When omitted, -xmx defaults to 1024m.
  • -compiler_jar specifies the absolute path to the Closure Compiler jar file. If not specified the latest installed version will be used.

Usage with Grunt and Gulp

Externs for ADVANCED_OPTIMIZATIONS

Externs for node.js

ClosureCompiler.js depends on the closurecompiler-externs package, an npm distribution of node.js Closure Compiler Externs, which includes externs for all of node's core modules. As a result, specifiying --externs=node automatically includes all node.js specific externs in your compile step. If you are using non-core modules, you may still need additional externs for these.

Updating

To update ClosureCompiler.js and/or the underlying Closure Compiler package, just run npm update. This will automatically download and set up the latest version of Closure Compiler to be used by ClosureCompiler.js.

Using custom Closure Compiler builds

If you want to use a custom Closure Compiler build for whatever reason, just replace the files in the compiler/ directory.

Tests Build Status

Contributors

Feross Aboukhadijeh

License

ClosureCompiler.js and Closure Compiler itself

Apache License, Version 2.0 - http://www.apache.org/licenses/LICENSE-2.0.html

Rhino

MPL 2.0 License - https://developer.mozilla.org/en-US/docs/Rhino/License

Bundled JRE

Binary License for OpenJDK - http://openjdk.java.net/legal/binary-license-2007-05-08.html

This package is not officially supported by Google, Mozilla or Oracle. All rights belong to their respective owners.

Current Tags

  • 1.6.1                                ...           latest (6 years ago)

27 Versions

  • 1.6.1                                ...           6 years ago
  • 1.6.0                                ...           6 years ago
  • 1.5.3                                ...           6 years ago
  • 1.5.2                                ...           7 years ago
  • 1.5.1                                ...           8 years ago
  • 1.5.0                                ...           8 years ago
  • 1.4.1                                ...           8 years ago
  • 1.4.0                                ...           8 years ago
  • 1.3.2                                ...           8 years ago
  • 1.3.1                                ...           8 years ago
  • 1.3.0                                ...           9 years ago
  • 1.2.0                                ...           9 years ago
  • 1.1.5                                ...           9 years ago
  • 1.1.4                                ...           9 years ago
  • 1.1.2                                ...           9 years ago
  • 1.1.1                                ...           9 years ago
  • 1.1.0                                ...           9 years ago
  • 1.0.7                                ...           9 years ago
  • 1.0.6                                ...           9 years ago
  • 1.0.5                                ...           9 years ago
  • 1.0.4                                ...           9 years ago
  • 1.0.3                                ...           9 years ago
  • 1.0.2                                ...           9 years ago
  • 1.0.0                                ...           9 years ago
  • 0.10.1                                ...           9 years ago
  • 0.9.2                                ...           9 years ago
  • 0.9.1                                ...           9 years ago
Maintainers (1)
Dependencies (3)
Dev Dependencies (0)
None

Copyright © npmmirror.com | 浙ICP备15033595号-63 |